//+------------------------------------------------------------------+
//|                                 !   T_Kiads BMI Long Mod v01.mq4 |
//|                 Original Copyright by:BlueMental, Mod by T_Kiads |
//|                                             http://www.kiads.net |
//+------------------------------------------------------------------+
#property copyright "Original Copyright by:BlueMental, Mod by T_Kiads"
#property link      "http://www.kiads.net"
#define PREFIX "1234"
#property indicator_separate_window
#property indicator_buffers 8
#property indicator_color1 DimGray     // 0 HistogramBuffer2
#property indicator_color2 Maroon      // 0 HistogramBuffer2
#property indicator_color3 Blue        // 1 HistogramBuffer1
#property indicator_color4 DodgerBlue  // 2 SignalLineGold
#property indicator_color5 White       // 3 MACDLineBuffer
#property indicator_color6 DeepPink    // 4 SignalLineBuffer
#property indicator_color7 DarkOrange  // 5 UpperLine
#property indicator_color8 SpringGreen // 6 LowerLine

#property indicator_width1 4
#property indicator_width2 4
#property indicator_width3 2
#property indicator_width4 3
#property indicator_width5 3
#property indicator_width6 3
#property indicator_width7 2
#property indicator_width8 2

#property indicator_level1    0
#property indicator_level2    200
#property indicator_level3    -200
#property indicator_level4    400
#property indicator_level5    -400
#property indicator_level6    800
#property indicator_level7    -800

#property indicator_levelwidth 1
#property indicator_levelcolor Aqua

//---- input parameters
extern int        FastMAPeriod   =  24;   //144 //75 
extern int        SlowMAPeriod   =  72;   //312 //365
extern int        SignalMAPeriod =  36;   //108 //60
extern int        MAmethod       =  1;
extern int        MAprice        =  4;
extern int        MAprecision    =  5;

extern bool       BBonSignal     =  true;
extern bool       BBonMACDline   =  true;
extern int        BBperiod       =  4;
extern double     BBdeviation    =  8;
extern int        BBshift        =  0;
extern int        BBprecision    =  3;

extern bool       Arrows         = true;
extern int        ArrowBars      = 1;
extern int        ArrowSize      = 2;
extern int        sensitivity    = 15;
extern int        otstup         = 5;
extern color      ArrUpcolor     = Gold;   
extern color      ArrDncolor     = Red;    

//---- buffers
double MACDLineBuffer[];
double SignalLineBuffer[];
double HistogramBuffer1[];
double HistogramBuffer2[];
double HistogramBuffer3[];
double SignalLineGold[];
double UpperLine[];
double LowerLine[];

//---- variables
double alpha = 0;
double alpha_1 = 0;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
{
   //   IndicatorDigits(MarketInfo(Symbol(),MODE_DIGITS)+1);
   //---- indicators
   SetIndexStyle        (0,DRAW_HISTOGRAM);
   SetIndexBuffer       (0,HistogramBuffer2);
   SetIndexDrawBegin    (0,SlowMAPeriod);
   
   SetIndexStyle        (1,DRAW_HISTOGRAM);
   SetIndexBuffer       (1,HistogramBuffer3);
   SetIndexDrawBegin    (1,SlowMAPeriod);
   
   SetIndexStyle        (2,DRAW_HISTOGRAM);
   SetIndexBuffer       (2,HistogramBuffer1);
   SetIndexDrawBegin    (2,0);//SlowMAPeriod+SignalMAPeriod);

   SetIndexStyle        (3,DRAW_LINE);
   SetIndexBuffer       (3,SignalLineGold);
   SetIndexDrawBegin    (3,SlowMAPeriod);

   SetIndexStyle        (4,DRAW_LINE);
   SetIndexBuffer       (4,MACDLineBuffer);
   SetIndexDrawBegin    (4,0);//SlowMAPeriod);

   SetIndexStyle        (5,DRAW_LINE);
   SetIndexBuffer       (5,SignalLineBuffer);  
   SetIndexDrawBegin    (5,SlowMAPeriod);//SlowMAPeriod+SignalMAPeriod);

   SetIndexStyle        (6,DRAW_LINE);
   SetIndexBuffer       (6,UpperLine);
   SetIndexDrawBegin    (6,0);

   SetIndexStyle        (7,DRAW_LINE);
   SetIndexBuffer       (7,LowerLine);  
   SetIndexDrawBegin    (7,0);
   
   //---- name for DataWindow and indicator subwindow label
   IndicatorShortName   ("T_Kiads BMI Long Mod v01("+FastMAPeriod+","+SlowMAPeriod+","+SignalMAPeriod+")");
   SetIndexLabel        (0,"MACD abv 0");
   SetIndexLabel        (1,"MACD blw 0");
   SetIndexLabel        (2,"Signal");
   SetIndexLabel        (4,"MACD");
   SetIndexLabel        (6,"UpLine");
   SetIndexLabel        (7,"LowLine");
   //----
	alpha =12.0 / (SignalMAPeriod + 6.0);
	alpha_1 = 1.0 - alpha;
   //----
   return(0);
}
//+------------------------------------------------------------------+
//| Custor indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
   Comment("");                                  
   for (int i = ObjectsTotal()-1; i >= 0; i--)   
   if (StringSubstr(ObjectName(i), 0, 
       StringLen(PREFIX)) == PREFIX)
       ObjectDelete(ObjectName(i));
   return(0); 
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
{
   int limit,i,j;
   int counted_bars = IndicatorCounted();
   //---- check for possible errors
   if (counted_bars<0) return(-1);
   //---- last counted bar will be recounted
   if (counted_bars>0) counted_bars--;
   limit = Bars - counted_bars;

   for(i=limit; i>=0; i--)
   {
      MACDLineBuffer[i]    =  (NormalizeDouble(((iMA(NULL,0,FastMAPeriod,0,MAmethod,MAprice,i)
                              -iMA(NULL,0,SlowMAPeriod,0,MAmethod,MAprice,i))),MAprecision)*100000);
      SignalLineBuffer[i]  =  NormalizeDouble(((alpha*MACDLineBuffer[i] + alpha_1*SignalLineBuffer[i+1])*1),MAprecision);

      SignalLineGold[i]    =  NormalizeDouble((MACDLineBuffer[i] - SignalLineBuffer[i])*12,MAprecision);
      HistogramBuffer1[i] =   NormalizeDouble((((MACDLineBuffer[i] - SignalLineBuffer[i])*12)),MAprecision);//-HistogramBuffer2[i+1];
      
      
      if       (MACDLineBuffer[i]>0)
               {
               HistogramBuffer2[i] =   NormalizeDouble(MACDLineBuffer[i],MAprecision);// - SignalLineGold[i];
               HistogramBuffer3[i] =   EMPTY_VALUE;
               }
      else if  (MACDLineBuffer[i]<0)
               {
               HistogramBuffer2[i] =   EMPTY_VALUE;
               HistogramBuffer3[i] =   NormalizeDouble(MACDLineBuffer[i],MAprecision);// - SignalLineGold[i];
               }
      
      
   }
   
   for(j=limit; j>=0; j--)
   {   
   if       (BBonSignal && !BBonMACDline)
            {
            UpperLine[j]   =NormalizeDouble(iBandsOnArray(SignalLineGold,0,BBperiod,BBdeviation,BBshift,1,j),BBprecision);
            LowerLine[j]   =NormalizeDouble(iBandsOnArray(SignalLineGold,0,BBperiod,BBdeviation,BBshift,2,j),BBprecision);
            }
   else if  (!BBonSignal && BBonMACDline)
            {
            UpperLine[j]   =NormalizeDouble(iBandsOnArray(MACDLineBuffer,0,BBperiod,BBdeviation,BBshift,1,j),BBprecision);
            LowerLine[j]   =NormalizeDouble(iBandsOnArray(MACDLineBuffer,0,BBperiod,BBdeviation,BBshift,2,j),BBprecision);
            }
   else if  (BBonSignal && BBonMACDline)
            {
            UpperLine[j]   =( NormalizeDouble(iBandsOnArray(SignalLineGold,0,BBperiod,BBdeviation,BBshift,1,j),BBprecision)+
                              NormalizeDouble(iBandsOnArray(MACDLineBuffer,0,BBperiod,BBdeviation,BBshift,1,j),BBprecision))/2;
            LowerLine[j]   =( NormalizeDouble(iBandsOnArray(SignalLineGold,0,BBperiod,BBdeviation,BBshift,2,j),BBprecision)+
                              NormalizeDouble(iBandsOnArray(MACDLineBuffer,0,BBperiod,BBdeviation,BBshift,2,j),BBprecision))/2;
            }
   else     {
            UpperLine[j]   =EMPTY_VALUE;
            LowerLine[j]   =EMPTY_VALUE;
            }
   }
//----
 if(Arrows){
  for(int k=limit; k>=0; k--) 
  {
 if(MACDLineBuffer[k+1+ArrowBars]<LowerLine[k+1+ArrowBars] && MACDLineBuffer[k+ArrowBars]>LowerLine[k+ArrowBars] && 
 MathAbs(MACDLineBuffer[k+1+ArrowBars]-LowerLine[k+1+ArrowBars])>sensitivity && 
 MathAbs(MACDLineBuffer[k+ArrowBars]-LowerLine[k+ArrowBars])>sensitivity)
 
     manageArr(k+ArrowBars,ArrUpcolor,233,false);
     
 if(MACDLineBuffer[k+1+ArrowBars]>UpperLine[k+1+ArrowBars] && MACDLineBuffer[k+ArrowBars]<UpperLine[k+ArrowBars] && 
 MathAbs(MACDLineBuffer[k+1+ArrowBars]-UpperLine[k+1+ArrowBars])>sensitivity && 
 MathAbs(MACDLineBuffer[k+ArrowBars]-UpperLine[k+ArrowBars])>sensitivity)  
 
     manageArr(k+ArrowBars,ArrDncolor,234,true);
  }
 }  
//----
   return(0);
}
//================================================================
void manageArr(int j, color clr, int theCode, bool up)   
{
   string objName = PREFIX + Time[j];
   double gap  = (3.0*iATR(NULL,0,20,j)/4.0)+otstup*Point;
   
   ObjectCreate(objName, OBJ_ARROW,0,Time[j],0);
   ObjectSet   (objName, OBJPROP_COLOR, clr);  
   ObjectSet   (objName, OBJPROP_ARROWCODE,theCode);
   ObjectSet   (objName, OBJPROP_WIDTH,ArrowSize);  
  if (up)
      ObjectSet(objName,OBJPROP_PRICE1,High[j]+gap);
     else  
      ObjectSet(objName,OBJPROP_PRICE1,Low[j] -gap);
}
//================================================================